import json
import requests
import base64
from google.cloud import firestore
import datetime;
import time
from confluence import *

auth = ("asad", "XXXXXXXXXXXXXXXXXXXXXXXX")
jenkins_uri = '34.81.121.147:8080'
def updateStatus(event, context):
    try:
        pubsub_message = base64.b64decode(event['data']).decode('utf-8')
        print(pubsub_message)
        print(type(pubsub_message))
        execution_details = json.loads(pubsub_message)
        job_url = 'http://{}/job/{}/job/{}/{}/api/json'.format(jenkins_uri,execution_details["projectName"], execution_details["artifactName"], execution_details["jobId"])
        print(job_url)
        j = requests.get(job_url,auth=auth)
        print ((j.status_code))
        jje = j.json()
        result = jje['result']
        print (result)
        if result == 'SUCCESS':
            print ("{}: Job: {} Status: {}".format(time.ctime(), execution_details["artifactName"], result))
            print("Result:  ", result) 
            execution_details["status"]=result
        elif result == 'FAILURE':
            print ("{}: Job: {} Status: {}".format(time.ctime(), execution_details["artifactName"], result))
            execution_details["status"]=result
        elif result == 'ABORTED':
            print ("{}: Job: {} Status: {}".format(time.ctime(), execution_details["artifactName"], result))
            execution_details["status"]=result
        else:
            print ("no status found")
    except Exception as e:
        print("Error: " + str(e))
    try:
        db = firestore.Client()
        ts =datetime.datetime.now()
        execution_details["timestamp"]=ts
        print(execution_details)
        db.collection(u'deploymentsStatus').add(execution_details)
        print("Deployment Status written to firestore collection")
    except Exception as e:
        print("Failed writing data to firestore")
        print("Error: " + str(e))
    updateConfluence(execution_details["projectName"],execution_details["artifactName"],execution_details["artifactVersion"],execution_details["environment"])

